# ------------------------------------------------------------------------------
# Book:         DSFM
# ------------------------------------------------------------------------------
# Quantlet:     Specclust
# ------------------------------------------------------------------------------
# Description:  Specclust computes the clusters for the exemplary data data_example.dat 
#               based on the Euclidean distance and predefined number of clusters 
#               It is also used to derive clusters for fMRI data (provided upon request at SFB649)
# ------------------------------------------------------------------------------
# Usage:        -
# ------------------------------------------------------------------------------
# Keywords:     spectral clustering, partitioning, proximity, cluster, grouping,
#               normalized cut, cut cost, fMRI  
# ------------------------------------------------------------------------------
# Inputs:       data_example.dat
# ------------------------------------------------------------------------------
# Output:       Plot of derived clusters 
# ------------------------------------------------------------------------------
# Example:     
# ------------------------------------------------------------------------------
# Author:       Piotr Majer
# ------------------------------------------------------------------------------

# close windows, clear variables
rm(list = ls(all = TRUE))
graphics.off()

install.packages("kernlab")
library(kernlab)

data = t(read.table(".../data_example.dat", quote=""))
sc   = specc(t(data), centers=4)
centers(sc)
size(sc)
withinss(sc)

plot(t(data), col=sc, xlab="",ylab="", cex.axis=2, lwd=2, pch=16)